# Emmy version 1.0.0
# EmmyLexer.py
# by Antoine Rauzy
# Copyrights (c) 2019 AltaRica Association
#
# This file is part of Emmy, a pedagogical stochastic simulator.
# Emmy is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# Emmy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with Emmy.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Lexer

# 1) Imported modules
# -------------------

from S2MLCore import *

from EmmyType import *

# 2) Lexer
# --------

# 2.1) Creator
# ------------

class EmmyLexer(S2MLLexer):

  def __init__(self, engine):
    S2MLLexer.__init__(self, engine)

# 2.2) Management of actions
# --------------------------

  def RegisterActions(self):
    S2MLLexer.RegisterActions(self)
    self.RegisterAction(":", EmmyLexer.ActionColon)

  def ActionColon(self, c):
    c = self.GetChar()
    if c=="=":
      c = self.GetChar()
      self.tokenString = ":="
      self.NewToken(EmmyType.TOKEN_ASSIGN)
    else:
      self.PutCharBack(c)
      self.tokenString = ":"
      self.NewToken(EmmyType.TOKEN_COLON)

# 2.3) Management of keywords
# ---------------------------

  def RegisterTokens(self):
    S2MLLexer.RegisterTokens(self)

  def RegisterKeywords(self):
    S2MLLexer.RegisterKeywords(self)
    self.RegisterKeyword("assertion", EmmyType.KEYWORD_ASSERTION)
    self.RegisterKeyword("probability", EmmyType.KEYWORD_PROBABILITY)
    self.RegisterKeyword("observer", EmmyType.KEYWORD_OBSERVER)
    self.RegisterKeyword("in", EmmyType.KEYWORD_IN)

