# Emmy version 1.0.0
# EmmyBlock.py
# by Antoine Rauzy
# Copyrights (c) 2019 AltaRica Association
#
# This file is part of Emmy, a pedagogical stochastic simulator.
# Emmy is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# Emmy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with Emmy.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) Blocks

# 1) Imported modules
# -------------------

from S2MLCore import *

from EmmyType import *

# 2) Blocks
# ---------

class EmmyBlock(S2MLBlock):
  def __init__(self, identifier, container):
    S2MLBlock.__init__(self, identifier, container)

  def SetIndicatorProfileOfObservers(self, profile):
    from EmmyModel import EmmyModel
    observers = []
    self.CollectElements(EmmyModel.IsObserver, True, observers) 
    for observer in observers:
      observer.SetIndicatorProfile(profile)

