# Emmy version 1.1.0
# EmmyType.py
# by Antoine Rauzy
# Copyrights (c) 2018 AltaRica Association
#
# This file is part of Emmy, a pedagogical stochastic simulator.
# Emmy is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# Emmy is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with Emmy.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) EmmyType
#   2.1) Tokens & keywords
#   2.2) Elements

# 1) Imported modules
# -------------------

from S2MLCore import *

# 2) S2MLType
# -----------

class EmmyType(S2MLType):

# 2.1) Tokens & keywords
# ----------------------

  # Tokens
  TOKEN_ASSIGN = 1101

  # Keywords
  KEYWORD_ASSERTION = 1201
  KEYWORD_OBSERVER = 1215
  KEYWORD_IN = 1216
  KEYWORD_PROBABILITY = 1221

# 2.2) Elements
# -------------

  VARIABLE = 1202
  ASSIGNMENT = 1212
  OBSERVER = 1215
  PROBABILITY_DECLARATION = 1221

