# S2MLCore version 1.0.0
# S2MLBaseBlock.py
# by Antoine Rauzy
# Copyrights (c) 2018 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) BaseBlocks

# 1) Imported modules
# -------------------

from S2MLDomains import *
from S2MLMetaModel import *

from S2MLType import *

# 2) BaseBlocks
# -------------

class S2MLBaseBlock(S2MLContainer):
  def __init__(self, type, identifier, container):
    S2MLContainer.__init__(self, type, container)
    path = S2MLPath.NewEmptyPath()
    path.AppendIdentifier(identifier)
    self.SetPath(path)
    self.Rename(identifier)

  def LookForBlock(self, identifier):
    from S2MLModel import S2MLModel
    element = self.LookForIdentifiedElement(identifier)
    if element==None or not S2MLModel.IsBlock(element):
      return None
    return element
  def CollectBlocks(self, recursive = False):
    from S2MLModel import S2MLModel
    blocks = []
    self.CollectElements(S2MLModel.IsBlock, recursive, blocks)
    return blocks
  def GetNumberOfBlocks(self):
    return len(self.CollectBlocks())
  def GetBlock(self, index):
    blocks = self.CollectBlocks()
    if index<0 or index>=len(blocks):
      return None
    return blocks[index]
