# S2MLCore version 1.0.0
# S2MLType.py
# by Antoine Rauzy
# Copyrights (c) 2018 AltaRica Association
#
# This file is part of S2MLCore.
# S2MLCore is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# S2MLCore is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with S2MLCore.  If not, see <http://www.gnu.org/licenses/>.

# Table of Contents
# -----------------
# 1) Imported modules
# 2) S2MLType
# 3) Tokens & keywords
# 4) S2ML elements
# 5) Stochastic expressions
# 6) Distributions

# 1) Imported modules
# -------------------

# 2) S2MLType
# -----------

class S2MLType:

# 3) Tokens & keywords
# --------------------

  # Generic tokens
  TOKEN_INTEGER = 1
  TOKEN_REAL = 2
  TOKEN_IDENTIFIER = 3
  TOKEN_PATH = 4
  TOKEN_COMMENT = 5
  TOKEN_NON_TERMINATED_COMMENT = 6
  TOKEN_UNKNOWN = 7

  # Symbols
  TOKEN_LPAR = 101
  TOKEN_RPAR = 102
  TOKEN_LBRACE = 103
  TOKEN_RBRACE = 104
  TOKEN_LBRACK = 105
  TOKEN_RBRACK = 106
  TOKEN_SEMICOLON = 107
  TOKEN_COMMA = 108
  TOKEN_COLON = 109
  TOKEN_EQUAL = 110
  TOKEN_EQ = 111
  TOKEN_PLUS = 112
  TOKEN_MINUS = 113
  TOKEN_STAR = 114
  TOKEN_SLASH = 115
  TOKEN_LT = 116
  TOKEN_LEQ = 117
  TOKEN_GT = 118
  TOKEN_GEQ = 119
  TOKEN_EXCLAMATION_MARK = 121
  TOKEN_DF = 122

  # Keywords for S2ML constructs
  KEYWORD_DOMAIN = 201
  KEYWORD_BLOCK = 203
  KEYWORD_CLASS = 204
  KEYWORD_END = 205
  KEYWORD_CLONES = 206
  KEYWORD_AS = 207
  KEYWORD_EMBEDS = 208
  KEYWORD_EXTENDS = 209
  KEYWORD_FUNCTION = 211
  KEYWORD_OPERATOR = 213
  KEYWORD_PARAMETER = 220
  KEYWORD_BOOLEAN = 231
  KEYWORD_INTEGER = 232
  KEYWORD_REAL = 233
  KEYWORD_SYMBOL = 234
  KEYWORD_STRING = 235
  KEYWORD_ANY = 236

  # Keywords for stochastic expressions
  KEYWORD_ADD = 311
  KEYWORD_SUB = 312
  KEYWORD_MUL = 313
  KEYWORD_DIV = 314
  KEYWORD_NEG = 315
  KEYWORD_MIN = 316
  KEYWORD_MAX = 317
  KEYWORD_PI = 318
  KEYWORD_FALSE = 321
  KEYWORD_TRUE = 322
  KEYWORD_AND = 323
  KEYWORD_OR  = 324
  KEYWORD_NOT = 325
  KEYWORD_EQ  = 331
  KEYWORD_DF  = 332
  KEYWORD_LT  = 333
  KEYWORD_GT  = 334
  KEYWORD_LEQ = 335
  KEYWORD_GEQ = 336
  KEYWORD_WITHIN = 337
  KEYWORD_COUNT = 341
  KEYWORD_IF = 342
  KEYWORD_UNIFORM_DEVIATE = 351
  KEYWORD_NORMAL_DEVIATE = 352
  KEYWORD_LOGNORMAL_DEVIATE = 353
  KEYWORD_TRIANGULAR_DEVIATE = 354
  KEYWORD_EXPONENTIAL_DEVIATE = 355
  KEYWORD_WEIBULL_DEVIATE = 356
  KEYWORD_PIECEWISE_UNIFORM_DEVIATE = 357
  KEYWORD_STEPWISE_DEVIATE = 358
  KEYWORD_MISSION_TIME = 361
  KEYWORD_EXP = 371
  KEYWORD_LOG = 372
  KEYWORD_POW = 373
  KEYWORD_SQRT = 374
  KEYWORD_FLOOR = 375
  KEYWORD_CEIL = 375
  KEYWORD_ABS = 376
  KEYWORD_MOD = 377
  KEYWORD_GAMMA = 378
  KEYWORD_SIN = 381
  KEYWORD_COS = 382
  KEYWORD_TAN = 383
  KEYWORD_ASIN = 384
  KEYWORD_ACOS = 385
  KEYWORD_ATAN = 386
  KEYWORD_CONSTANT_DISTRIBUTION = 391
  KEYWORD_EXPONENTIAL_DISTRIBUTION = 392
  KEYWORD_GLM_DISTRIBUTION = 393
  KEYWORD_WEIBULL_DISTRIBUTION = 394
  KEYWORD_DIRAC_DISTRIBUTION = 395
  KEYWORD_PIECEWISE_UNIFORM_DISTRIBUTION = 397
  KEYWORD_STEPWISE_DISTRIBUTION = 398

# 4) S2ML elements
# ----------------

  UNKNOWN = 0

  DOMAIN_DECLARATION = 201
  BLOCK = 203
  CLASS = 204
  CLONES = 206
  EMBEDS = 208
  EXTENDS = 209
  INSTANCE = 210
  FUNCTION = 211
  FUNCTION_CALL = 212
  OPERATOR = 213
  MODEL = 214
  PORT = 215
  PARAMETER = 220

# 5) Stochastic expressions
# -------------------------

  REFERENCE_EXPRESSION = 301
  CONSTANT_EXPRESSION = 302
  OPERATOR_CALL_EXPRESSION = 303
  ADD_EXPRESSION = 311
  SUB_EXPRESSION = 312
  MUL_EXPRESSION = 313
  DIV_EXPRESSION = 314
  NEG_EXPRESSION = 315
  MIN_EXPRESSION = 316
  MAX_EXPRESSION = 317
  AND_EXPRESSION = 323
  OR_EXPRESSION  = 324
  NOT_EXPRESSION = 325
  EQ_EXPRESSION  = 331
  DF_EXPRESSION  = 332
  LT_EXPRESSION  = 333
  GT_EXPRESSION  = 334
  LEQ_EXPRESSION = 335
  GEQ_EXPRESSION = 336
  WITHIN_EXPRESSION = 337
  COUNT_EXPRESSION = 341
  IF_EXPRESSION = 342
  UNIFORM_DEVIATE_EXPRESSION = 351
  NORMAL_DEVIATE_EXPRESSION = 352
  LOGNORMAL_DEVIATE_EXPRESSION = 353
  TRIANGULAR_DEVIATE_EXPRESSION = 354
  EXPONENTIAL_DEVIATE_EXPRESSION = 355
  WEIBULL_DEVIATE_EXPRESSION = 356
  PIECEWISE_UNIFORM_DEVIATE_EXPRESSION = 357
  STEPWISE_DEVIATE_EXPRESSION = 358
  MISSION_TIME_EXPRESSION = 361
  EXP_EXPRESSION = 371
  LOG_EXPRESSION = 372
  POW_EXPRESSION = 373
  SQRT_EXPRESSION = 374
  FLOOR_EXPRESSION = 375
  CEIL_EXPRESSION = 375
  ABS_EXPRESSION = 376
  MOD_EXPRESSION = 377
  GAMMA_EXPRESSION = 378
  SIN_EXPRESSION = 381
  COS_EXPRESSION = 382
  TAN_EXPRESSION = 383
  ASIN_EXPRESSION = 384
  ACOS_EXPRESSION = 385
  ATAN_EXPRESSION = 386
  CONSTANT_DISTRIBUTION_EXPRESSION = 391
  EXPONENTIAL_DISTRIBUTION_EXPRESSION = 392
  GLM_DISTRIBUTION_EXPRESSION = 393
  WEIBULL_DISTRIBUTION_EXPRESSION = 394
  DIRAC_DISTRIBUTION_EXPRESSION = 395
  PIECEWISE_UNIFORM_DISTRIBUTION_EXPRESSION = 397
  STEPWISE_DISTRIBUTION_EXPRESSION = 398

